﻿var buddyListForInvitePage;
var buddyList;
var buddyListInviteTemplateContainer;
var btnInviteSelectedBuddyFromBuddyList;
var buddyListContiner;
var lblNoBuddiesForSelect;
var btnFromBuddyListForInviteToFindPartner;


function initBuddyListForInvite() {
    buddyListForInvitePage = document.getElementById('buddyListForInvitePage');
    buddyList = document.getElementById('buddyList');
    buddyListInviteTemplateContainer = document.getElementById('buddyListInviteTemplateContainer');
    btnInviteSelectedBuddyFromBuddyList = document.getElementById('btnInviteSelectedBuddyFromBuddyList');
    btnFromBuddyListForInviteToFindPartner = document.getElementById('btnFromBuddyListForInviteToFindPartner');
    lblNoBuddiesForSelect = document.getElementById('lblNoBuddiesForSelect');
    buddyListContiner = document.getElementById('buddyListContiner');

    registerClickFor(btnFromBuddyListForInviteToFindPartner, function () {
        showOnly(findPartnerPage);
    });

    registerClickFor(btnInviteSelectedBuddyFromBuddyList, function () {
        var selectedUsers = $(".selected", buddyList);

        if (selectedUsers.length != 1) {
            simFamily.signalrController.hub.client.displayToUser("Je moet een vriend selecteren.");
            return;
        }

        selectedOpponentId = getDatasetValue(selectedUsers[0].parentElement, 'userid');
        isRandomGameRequest = false;

        disableControl(btnInviteSelectedBuddyFromBuddyList);

        showOnly(profilesPage);
    });

    buddyListForInvitePage.loadData = function () {
        emptyElement(buddyList);
        if (simFamily.domainController.domain.favorites.length > 0) {
            $(lblNoBuddiesForSelect).hide();
            $(buddyListContiner).show();
            for (var i = 0; i < simFamily.domainController.domain.favorites.length; i++) {
                var item = $(buddyListInviteTemplateContainer.children[0]).clone();
                
                setDatasetValue(item, 'userid', simFamily.domainController.domain.favorites[i].id);
                $('.inviteeName', item).text(simFamily.domainController.domain.favorites[i].username);

                registerClickFor(item[0], function () {
                    var $checkbox = $('.checkbox', this);
                    var shouldCheck = !$checkbox.hasClass('selected');

                    $('.checkbox.selected', this.parentNode).removeClass('selected');

                    if (shouldCheck) {
                        $checkbox.addClass('selected');
                        enableControl(btnInviteSelectedBuddyFromBuddyList);
                    }
                    else {
                        disableControl(btnInviteSelectedBuddyFromBuddyList);
                    }
                });
                activateClickListenersFor(item[0]);

                buddyList.appendChild(item[0]);
            }
        }
        else {
            $(lblNoBuddiesForSelect).show();
            $(buddyListContiner).hide();
        };

        buddyListForInvitePage.onDataLoaded();
    };
    

    buddyListForInvitePage.beforeShowing = function () {
        disableControl(btnInviteSelectedBuddyFromBuddyList);
        $(lblNoBuddiesForSelect).hide();
        $(buddyListContiner).hide();
        activateClickListenersFor(btnFromBuddyListForInviteToFindPartner);
    };

    buddyListForInvitePage.beforeLeaving = function () {
        setBackgroundPatternFor('educator');
        $(lblNoBuddiesForSelect).hide();
        deactivateClickListenersFor(btnInviteSelectedBuddyFromBuddyList);
        deactivateClickListenersFor(btnFromBuddyListForInviteToFindPartner);
        emptyElement(buddyList);
    };
}