﻿var buddyListManagementPage;
var buddyListManagementPageList;
var buddyListManagementTemplateContainer;
var btnBuddyListManagementRemoveUser;
var lblNoBuddiesForManagement;
var btnFromBuddyListManagementToDashboard;
var buddyListManagementContainer;

function initBuddyListManagemet() {
    buddyListManagementPage = document.getElementById('buddyListManagementPage');
    buddyListManagementPageList = document.getElementById('buddyListManagementPageList');
    buddyListManagementTemplateContainer = document.getElementById('buddyListManagementTemplateContainer');
    btnBuddyListManagementRemoveUser = document.getElementById('btnBuddyListManagementRemoveUser');
    lblNoBuddiesForManagement = document.getElementById('lblNoBuddiesForManagement');
    btnFromBuddyListManagementToDashboard = document.getElementById('btnFromBuddyListManagementToDashboard');
    buddyListManagementContainer = document.getElementById('buddyListManagementContainer');

    registerClickFor(btnFromBuddyListManagementToDashboard, function () {
        showOnly(dashboardPage);
    });


    registerClickFor(btnBuddyListManagementRemoveUser, function () {
        var selectedUsers = $('.selected', buddyListManagementPageList);

        if (selectedUsers.length > 0) {

            var selectedUserIds = '';

            for (var i = 0; i < selectedUsers.length; i++) {
                selectedUserIds += getDatasetValue(selectedUsers[i].parentElement, 'userid') + ',';
            };
            selectedUserIds = selectedUserIds.substring(0, selectedUserIds.length - 1);

            //simFamily.signalrController.hub.server.removeBuddiesFor(simFamily.mainController.loggedInUserId, selectedUserIds);
            executeServerCall('removeBuddiesFor', [simFamily.mainController.loggedInUserId, selectedUserIds]);
        };
    });

    buddyListManagementPage.loadData = function () {
        emptyElement(buddyListManagementPageList);

        if (simFamily.domainController.domain.favorites.length > 0) {
            for (var i = 0; i < simFamily.domainController.domain.favorites.length; i++) {
                var item = $(buddyListManagementTemplateContainer.children[0]).clone();

                setDatasetValue(item, 'userid', simFamily.domainController.domain.favorites[i].id);

                $('.inviteeName', item).text(simFamily.domainController.domain.favorites[i].username);

                registerClickFor(item[0], function () {
                    var $checkbox = $('.checkbox', this);
                    if (!$checkbox.hasClass('selected')) {
                        $checkbox.addClass('selected');
                        enableControl(btnBuddyListManagementRemoveUser);
                    }
                    else {
                        $checkbox.removeClass('selected');

                        if ($('.selected', buddyListManagementPageList).length == 0) {
                            disableControl(btnBuddyListManagementRemoveUser);
                        };
                    };
                });
                activateClickListenersFor(item[0]);

                buddyListManagementPageList.appendChild(item[0]);
            }

            $(buddyListManagementContainer).show();
        }
        else {
            $(lblNoBuddiesForManagement).show();
        };

        buddyListManagementPage.onDataLoaded();
    };

    simFamily.signalrController.hub.client.onBuddiesRemoved = function () {
        showOnly(buddyListManagementPage);
    };

    buddyListManagementPage.beforeShowing = function () {
        setBackgroundPatternFor('educator');
        disableControl(btnBuddyListManagementRemoveUser);

        $(lblNoBuddiesForManagement).hide();
        $(buddyListManagementContainer).hide();
        activateClickListenersFor(btnFromBuddyListManagementToDashboard);
    };

    buddyListManagementPage.beforeLeaving = function () {
        deactivateClickListenersFor(btnBuddyListManagementRemoveUser);
        deactivateClickListenersFor(btnFromBuddyListManagementToDashboard);
    };
}