﻿simFamily.domainController = {};
simFamily.domainController.safeMethodQueue = [];
simFamily.domainController.safeMethodQueueExecutionInProgress = false;
simFamily.domainController.domain = {};
simFamily.domainController.domain.profiles = [];
simFamily.domainController.domain.games = [];
//simFamily.domainController.domain.ownTurnGames = [];
//simFamily.domainController.domain.opponentTurnGames = [];
//simFamily.domainController.domain.receivedInvitations = [];
//simFamily.domainController.domain.finishedGames = [];
simFamily.domainController.domain.favorites = [];


simFamily.domainController.refreshInProgress = false;

simFamily.domainController.executeSafeMethodQueue = function () {
    if (simFamily.domainController.safeMethodQueue.length == 0) {
        simFamily.domainController.safeMethodQueueExecutionInProgress = false;
        simFamily.domainController.onSafeMethodExecuted = null;
        return;
    };
    simFamily.domainController.safeMethodQueueExecutionInProgress = true;
    simFamily.domainController.onSafeMethodExecuted = function () {
        simFamily.domainController.safeMethodQueue.splice(0, 1);
        simFamily.domainController.executeSafeMethodQueue();
    };
    simFamily.signalrController.client[simFamily.domainController.safeMethodQueue[0].method](simFamily.domainController.safeMethodQueue.params);
}


simFamily.domainController.executeSafely = function (_method, _params) {
    simFamily.domainController.safeMethodQueue.push({ method: _method, params: _params });
    simFamily.domainController.executeSafeMethodQueue();
}

simFamily.domainController.getGameById = function (id) {
    if (!hasValue(simFamily) || !hasValue(simFamily.domainController) || !hasValue(simFamily.domainController.domain)) return null;

    if (hasValue(simFamily.domainController.domain.games)) {
        for (i = 0; i < simFamily.domainController.domain.games.length; i++) {
            if (simFamily.domainController.domain.games[i].gameId == id) {
                return simFamily.domainController.domain.games[i];
            }
        }
    }

    return null;
}

simFamily.domainController.removeGame = function (gameId) {
    var index = -1;
    for (i = 0; i < simFamily.domainController.domain.games.length; i++) {
        if (simFamily.domainController.domain.games[i].gameId == gameId) {
            index = i;
            break;
        }
    }

    if (index > -1) {
        simFamily.domainController.domain.games.splice(i, 1);
    }
}

simFamily.domainController.removeGames = function (gameIds) {
    for (j = 0; j < gameIds.length; j++) {
        simFamily.domainController.removeGame(gameIds[j]);
    }
}

simFamily.domainController.addGames = function (games) {
    for (k = 0; k < games.length; k++) {
        //var gameReplaced = false;
        for (m = 0; m < simFamily.domainController.domain.games.length; m++) {
            if (simFamily.domainController.domain.games[m].gameId == games[k].gameId) {
                simFamily.domainController.domain.games.splice(m, 1);
                //simFamily.domainController.domain.games[m] = games[k];
                //gameReplaced = true;
                //break;
            }
        }

        //if (gameReplaced == false) {
            simFamily.domainController.domain.games.push(games[k]);
        //}
    }
}

simFamily.domainController.hasOpponentAsBuddy = function (opponentUsername) {
    for (l = 0; l < simFamily.domainController.domain.favorites.length; l++) {
        if (simFamily.domainController.domain.favorites[l].username == opponentUsername) {
            return true;
        }
    }

    return false;
}


simFamily.domainController.sortGamesByLastActivityDesc = function () {
    var changesMade;
    var temp;

    do {
        changesMade = false;

        for (i = 0; i < simFamily.domainController.domain.games.length - 1; i++) {
            if (simFamily.domainController.domain.games[i].lastActivity > simFamily.domainController.domain.games[i + 1].lastActivity) {
                temp = simFamily.domainController.domain.games[i];
                simFamily.domainController.domain.games[i] = simFamily.domainController.domain.games[i + 1];
                simFamily.domainController.domain.games[i + 1] = temp;

                changesMade = true;
            }
        }
    }
    while (changesMade == true);
}