﻿var simFamily;
var latestServerCallTimestamp = 0;
if (simFamily == undefined || simFamily == null) {
    simFamily = {};
}

simFamily.mainController = {};
simFamily.mainController.deviceIsReady = false;
simFamily.mainController.isInitialLoginAfterStart = true;

simFamily.mainController.gameStatus = {
    waitingForRandomMatch: 0,
    waitingForInviteeToJoin: 1,
    waintingForMoleToChooseScenario: 2,
    waintingForEducatorToChooseAnswer: 3,
    waintingForMoleToChooseReaction: 4,
    finished: 5,
    waitingForUsersToReadAnswerOverview: 6,
    waitingForRemainingUserToReadAnswerOverview: 7
}

if (touchIsSupported()) {
    simFamily.mainController.isOnline = false;
}
else {
    simFamily.mainController.isOnline = true;
};


simFamily.mainController.onPause = function () {
    setTimeout(function () {
    }, 0);
}

simFamily.mainController.onResign = function () {
    setTimeout(function () {
    }, 0);
}

simFamily.mainController.onResume = function () {
    setTimeout(function () {
        performMainLogin();
    }, 0);
}

simFamily.mainController.onActive = function () {
    setTimeout(function () {
 
    }, 0);
}

simFamily.mainController.onOnline = function () {
    setTimeout(function () {
        simFamily.mainController.isOnline = true;
        performMainLogin('online');
    }, 0);
}

simFamily.mainController.onOffline = function () {
    setTimeout(function () {
        simFamily.mainController.isOnline = false;
        performMainLogin();
    }, 0);
}

simFamily.mainController.onBackButton = function () {
    return false;
}

simFamily.mainController.onMenuButton = function () {
    alert('onMenuButton');
    return false;
    return;
}

simFamily.mainController.onSearchButton = function () {
    alert('onSearchButton');
    return false;
    return;
}

simFamily.mainController.setupHub = function () {
    initMaster();
    initRegister();
    initLogin();
    initTutorial();
    initDashboard();
    initFindPartner();
    initFindPartnerByUsernameOrEmail();
    initBuddyListForInvite();
    initProfiles();
    initGameboard();
    initHome();
    initMood();
    initResults();
    initConfrontationResults();
    initBuddyListManagemet();
    initRole();
    initHistory();
    initInstallationInvite();
    initAboutHorizon();
    initPrivacy();
    initDisclaimer();
}

simFamily.mainController.onDeviceReady = function (evt) {
    simFamily.mainController.deviceIsReady = true;
    simFamily.signalrController.initSignalR();
    simFamily.mainController.setupHub();
    simFamily.hintController.init();

    performMainLogin('deviceready');
};

document.addEventListener('deviceready', simFamily.mainController.onDeviceReady, false);
document.addEventListener('pause', simFamily.mainController.onPause, false);
//document.addEventListener('resign', simFamily.mainController.onResign, false);
document.addEventListener('resume', simFamily.mainController.onResume, false);
//document.addEventListener('active', simFamily.mainController.onActive, false);
document.addEventListener('online', simFamily.mainController.onOnline, false);
document.addEventListener('offline', simFamily.mainController.onOffline, false);
document.addEventListener('backbutton', simFamily.mainController.onBackButton, false);
//document.addEventListener('menubutton', simFamily.mainController.onMenuButton, false);
//document.addEventListener('searchbutton', simFamily.mainController.onSearchButton, false);


$(document).ready(function () {
    if (!touchIsSupported()) {
        simFamily.mainController.onDeviceReady();
    };
});