﻿simFamily.signalrController = {};

simFamily.signalrController.initSignalR = function () {
    $.support.cors = true;

    simFamily.signalrController.hub = {};
    simFamily.signalrController.hub.client = {};
    simFamily.signalrController.hub.server = {};
};


function performMainLogin(sender) {
    //alert('begin performing main login from ' + sender);
    if (simFamily.mainController.deviceIsReady != true) {
        //alert('deviceIsReady is false. quit.');
        return;
    }

    if (simFamily.mainController.isOnline != true) {
        $(infConnectionUnavailable).show();
        //alert('isOnline is false. quit.');
        return;
    }

    $(infConnectionUnavailable).hide();

    if (hasValue(simFamily.mainController.loggedInUserId)) {
        serverExecTimer = setTimeout(function () { executeServerCall(''); }, simFamily.settingsController.serverPollingInterval);
        return;
    }

    if (!hasValue(localStorage.SimFamily_Username)) {
        executeServerCall('anonymousLogin', [localStorage.SimFamily_Anonymous_Username]);
    }
    else {
        executeServerCall('login', [localStorage.SimFamily_Username, true, localStorage.SimFamily_Anonymous_Username]);
    };
}
