﻿var findPartnerByUsernameOrEmailPage;
var btnSearchForFilterUsernameOrEmail;
var findPartnerByUsernameOrEmailFilter;
var searchTermTemplateContainer;
var searchResultsList;
var searchResultsForFilter;
var btnSubmitSelectedBuddyFromSearchFilter;
var lblNoUsersFound;
var btnFromFindPartnerByUEToFindPartner;
function initFindPartnerByUsernameOrEmail() {
    findPartnerByUsernameOrEmailPage = document.getElementById('findPartnerByUsernameOrEmailPage');
    btnSearchForFilterUsernameOrEmail = document.getElementById('btnSearchForFilterUsernameOrEmail');
    btnSubmitSelectedBuddyFromSearchFilter = document.getElementById('btnSubmitSelectedBuddyFromSearchFilter');
    findPartnerByUsernameOrEmailFilter = document.getElementById('findPartnerByUsernameOrEmailFilter');
    searchTermTemplateContainer = document.getElementById('searchTermTemplateContainer');
    searchResultsList = document.getElementById('searchResultsList');
    searchResultsForFilter = document.getElementById('searchResultsForFilter');
    lblNoUsersFound = document.getElementById('lblNoUsersFound');
    btnFromFindPartnerByUEToFindPartner = document.getElementById('btnFromFindPartnerByUEToFindPartner');

    registerClickFor(btnFromFindPartnerByUEToFindPartner, function () {
        showOnly(homePage);
    });

    registerClickFor(btnSearchForFilterUsernameOrEmail, function () {
        emptyElement(searchResultsList);
        findPartnerByUsernameOrEmailFilter.blur();

        if (findPartnerByUsernameOrEmailFilter.value != 'undefined' && findPartnerByUsernameOrEmailFilter.value.length > 0) {
            //simFamily.signalrController.hub.server.findPartnerByUsernameOrEmailAddress(findPartnerByUsernameOrEmailFilter.value, simFamily.mainController.loggedInUserId);
            executeServerCall('findPartnerByUsernameOrEmailAddress', [findPartnerByUsernameOrEmailFilter.value, simFamily.mainController.loggedInUserId]);
        }
        else {
            $(lblNoUsersFound).show();
            $(searchResultsForFilter).hide();
        };

        disableControl(btnSubmitSelectedBuddyFromSearchFilter);
    });

    registerClickFor(btnSubmitSelectedBuddyFromSearchFilter, function () {
        disableControl(btnSubmitSelectedBuddyFromSearchFilter);

        findPartnerByUsernameOrEmailFilter.blur();

        var selectedUsers = $(".selected", searchResultsList);

        if (selectedUsers.length != 1) {
            simFamily.signalrController.hub.client.displayToUser("Je moet een gebruiker selecteren.");
            return;
        }

        selectedOpponentId = getDatasetValue(selectedUsers[0].parentElement, 'userid');
        isRandomGameRequest = false;
        showOnly(profilesPage);
    });

    simFamily.signalrController.hub.client.setSearchTermResults = function (data) {
        if (data.users.length > 0) {
            $(lblNoUsersFound).hide();
            $(searchResultsForFilter).show();
            $(btnSubmitSelectedBuddyFromSearchFilter).show();

            for (var i = 0; i < data.users.length; i++) {
                var item = $(searchTermTemplateContainer.children[0]).clone();

                setDatasetValue(item, 'userid', data.users[i].id);

                $('.inviteeName', item).text(data.users[i].username);

                registerClickFor(item[0], function () {
                    var $checkbox = $('.checkbox', this);
                    var shouldCheck = !$checkbox.hasClass('selected');

                    $('.checkbox.selected', this.parentNode).removeClass('selected');

                    if (shouldCheck) {
                        $checkbox.addClass('selected');
                        enableControl(btnSubmitSelectedBuddyFromSearchFilter);
                    }
                    else {
                        disableControl(btnSubmitSelectedBuddyFromSearchFilter);
                    }
                });
                activateClickListenersFor(item[0]);

                searchResultsList.appendChild(item[0]);
            }

            if (data.users.length == 1) {
                $(".checkbox", searchResultsList).addClass('selected');
                enableControl(btnSubmitSelectedBuddyFromSearchFilter);
            };
        }
        else {
            disableControl(btnSubmitSelectedBuddyFromSearchFilter);
            $(lblNoUsersFound).show();
            $(searchResultsForFilter).hide();
        };
    };


    findPartnerByUsernameOrEmailPage.beforeShowing = function () {
        setBackgroundPatternFor('educator');
        activateClickListenersFor(btnSearchForFilterUsernameOrEmail);
        disableControl(btnSubmitSelectedBuddyFromSearchFilter);
        activateClickListenersFor(btnFromFindPartnerByUEToFindPartner);
        emptyElement(searchResultsList);
        findPartnerByUsernameOrEmailFilter.value = '';
        $(searchResultsForFilter).hide();
    };

    findPartnerByUsernameOrEmailPage.loadData = function () {
        findPartnerByUsernameOrEmailPage.onDataLoaded();
    };

    findPartnerByUsernameOrEmailPage.beforeLeaving = function () {
        deactivateClickListenersFor(btnSearchForFilterUsernameOrEmail);
        deactivateClickListenersFor(btnSubmitSelectedBuddyFromSearchFilter);
        deactivateClickListenersFor(btnFromFindPartnerByUEToFindPartner);
        $(lblNoUsersFound).hide();
        emptyElement(searchResultsList);
        findPartnerByUsernameOrEmailFilter.value = '';

        findPartnerByUsernameOrEmailFilter.blur();
    };
}