﻿var loginPage;
var btnLogin;
var txtUsernameOrEmail;
var btnGoToRegister;
var loggedInUserName = '';
var userHasLoggedInBefore = true;
var btnFromLoginToHome;

function initLogin() {
    loginPage = document.getElementById('loginPage');
    btnLogin = document.getElementById('btnLogin');
    txtUsernameOrEmail = document.getElementById('txtUsernameOrEmail');
    btnGoToRegister = document.getElementById('btnGoToRegister');
    btnFromLoginToHome = document.getElementById('btnFromLoginToHome');

    registerClickFor(btnFromLoginToHome, function () {
        showOnly(homePage);
    });

    registerClickFor(btnLogin, function () {
        txtUsernameOrEmail.blur();
        if (isEmpty(txtUsernameOrEmail.value)) {
            simFamily.signalrController.hub.client.displayToUser('Gebruikersnaam is vereist.');
            return;
        }
        executeServerCall('login', [ txtUsernameOrEmail.value,  false,  localStorage.SimFamily_Anonymous_Username ]);
    });


    registerClickFor(btnGoToRegister, function () {
        txtUsernameOrEmail.blur();
        showOnly(registerPage);
    });

    //simFamily.signalrController.hub.client.onLogout = function () {
    //    simFamily.mainController.loggedInUserId = null;
    //    localStorage.SimFamily_Username = null;

    //    performMainLogin();
    //};

    simFamily.signalrController.hub.client.onAnonymousUserLoggedIn = function (data) {
        if (data.userId != undefined && data.userId != null && data.userId != '') {
            simFamily.mainController.loggedInUserId = data.userId;
            localStorage.SimFamily_Anonymous_Username = data.username;
            localStorage.SimFamily_Username = '';
            loggedInUserName = data.username;
            setGenderForSettingsPage(data.gender);
            simFamily.signalrController.hub.client.updateHintsViewed(data.hintsViewed);


            if (simFamily.gameController.gameCreationInProgress == true &&
                (simFamily.gameController.currentGameMode == simFamily.gameController.gameMode.multiplayerLevel1
                || simFamily.gameController.currentGameMode == simFamily.gameController.gameMode.multiplayerLevel2)
                ) {
                showOnly(loginPage);
            }
            else {
                disclaimerPage.hasLoggedInBefore = data.hasLoggedInBefore;
                showOnly(disclaimerPage);
                //if (data.hasLoggedInBefore === true) {
                //    showOnly(disclaimerPage);
                //}
                //else {
                //    showOnly(tutorialPage);
                //    userHasLoggedInBefore = false;
                //}
            }
        }
    };

    simFamily.signalrController.hub.client.onAnonymousLoginFailed = function () {
        simFamily.mainController.loggedInUserId = null;
        localStorage.SimFamily_Anonymous_Username = '';

        performMainLogin();
    };



    simFamily.signalrController.hub.client.onUserLoggedIn = function (data) {
        if (data.userId != undefined && data.userId != null && data.userId != '') {
            simFamily.mainController.loggedInUserId = data.userId;
            loggedInUserName = data.username;
            localStorage.SimFamily_Username = data.username;
            setGenderForSettingsPage(data.gender);
            simFamily.signalrController.hub.client.updateHintsViewed(data.hintsViewed);


            if (simFamily.gameController.gameCreationInProgress == true) {
                showOnly(findPartnerPage);
            }
            else {
                disclaimerPage.hasLoggedInBefore = data.hasLoggedInBefore;
                showOnly(disclaimerPage);
                //if (data.hasLoggedInBefore === true) {
                //    showOnly(disclaimerPage);
                //}
                //else {
                //    showOnly(tutorialPage);
                //    userHasLoggedInBefore = false;
                //}
            }
        }
    };

    simFamily.signalrController.hub.client.onLoginFailed = function (reason) {
        simFamily.mainController.loggedInUserId = null;
        localStorage.SimFamily_Username = '';

        if (reason == 'userNotFound') {
            if (simFamily.gameController.gameCreationInProgress == true) {
                simFamily.signalrController.hub.client.displayToUser("No user with the specified username or email was found.");
                showOnly(loginPage);
            }
            else {
                performMainLogin();
            }
        }

        if (reason == 'userAlreadyLoggedIn') {
            if (simFamily.gameController.gameCreationInProgress == true) {
                simFamily.signalrController.hub.client.displayToUser("Iemand met dezelfde gebruikersnaam is al ingelogd.");
                showOnly(loginPage);
            }
            else {
                performMainLogin();
            }
        }
    };



    simFamily.signalrController.hub.client.goToLoginPage = function () {
        showOnly(loginPage);
    };

    loginPage.beforeShowing = function () {
        setBackgroundPatternFor('educator');
        activateClickListenersFor(btnLogin);
        activateClickListenersFor(btnGoToRegister);
        txtUsernameOrEmail.value = '';
        activateClickListenersFor(btnFromLoginToHome);
    };

    loginPage.loadData = function () {
        loginPage.onDataLoaded();
    };

    loginPage.beforeLeaving = function () {
        txtUsernameOrEmail.blur();
        deactivateClickListenersFor(btnLogin);
        deactivateClickListenersFor(btnGoToRegister);
        deactivateClickListenersFor(btnFromLoginToHome);
    };
}