﻿var moodPage;
var moodImage;
var btnFromMoodToGame;

function initMood() {
    moodPage = document.getElementById('moodPage');
    moodImage = document.getElementById('moodImage');
    btnFromMoodToGame = document.getElementById('btnFromMoodToGame');

    registerClickFor(btnFromMoodToGame, function () {
        showOnly(gameboardPage, { id: simFamily.gameController.currentGameId });
    });

    moodPage.beforeShowing = function () {
        setBackgroundPatternFor('educator');
        $(moodImage).removeClass();
        activateClickListenersFor(btnFromMoodToGame);
    };

    moodPage.loadData = function (params) {
        var game = simFamily.domainController.getGameById(params.gameId);

        if (game.state == simFamily.mainController.gameStatus.finished) {
            showOnly(resultsPage, params);
            return;
        }

        $(moodImage).addClass('level' + game.moodLevel);
        $(moodImage).addClass(game.moodGoal);

        moodPage.onDataLoaded();
    };

    moodPage.beforeLeaving = function () {
        deactivateClickListenersFor(btnFromMoodToGame);
    };
}