﻿var installationInvitePage;
var txtFriendEmail;
var btnSendInstallationInvitation;
var installationInviteGoBack;
var btnFromInstallationInviteToDashboard;

function initInstallationInvite() {
    installationInvitePage = document.getElementById('installationInvitePage');
    txtFriendEmail = document.getElementById('txtFriendEmail');
    btnSendInstallationInvitation = document.getElementById('btnSendInstallationInvitation');
    btnFromInstallationInviteToDashboard = document.getElementById('btnFromInstallationInviteToDashboard');

    registerClickFor(btnFromInstallationInviteToDashboard, function () {
        txtFriendEmail.blur();
        showOnly(dashboardPage);
    });

    simFamily.signalrController.hub.client.onInstallationInviteSent = function () {
        simFamily.signalrController.hub.client.displayToUser('Je uitnodiging is verzonden.');
        txtFriendEmail.value = '';
        showOnly(dashboardPage);
    }

    registerClickFor(btnSendInstallationInvitation, function () {
        disableControl(btnSendInstallationInvitation);
        txtFriendEmail.blur();

        if (txtFriendEmail.value == '' || !validateEmail(txtFriendEmail.value)) {
            simFamily.signalrController.hub.client.displayToUser('E-mailadres is niet juist.');
            return;
        };

        //simFamily.signalrController.hub.server.sendInstallationInvite(simFamily.mainController.loggedInUserId, txtFriendEmail.value);
        executeServerCall('sendInstallationInvite', [ simFamily.mainController.loggedInUserId,  txtFriendEmail.value ]);
    });


    installationInvitePage.beforeShowing = function () {
        setBackgroundPatternFor('educator');
        txtFriendEmail.value = '';
        enableControl(btnSendInstallationInvitation);
        activateClickListenersFor(btnFromInstallationInviteToDashboard);
    };

    installationInvitePage.loadData = function (params) {
        installationInvitePage.onDataLoaded();
    };

    installationInvitePage.beforeLeaving = function () {
        txtFriendEmail.value = '';
        deactivateClickListenersFor(btnFromInstallationInviteToDashboard);
        deactivateClickListenersFor(btnSendInstallationInvitation);
    };
}